Index: trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.2.csproj	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/HeuristicLab.SGA-3.2.csproj	(revision 1865)
@@ -0,0 +1,158 @@
+﻿<Project DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003" ToolsVersion="3.5">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{E39AF78A-9692-472B-B061-E2F1B1AB2C92}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.SGA</RootNamespace>
+    <AssemblyName>HeuristicLab.SGA-3.2</AssemblyName>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+    <FileUpgradeFlags>
+    </FileUpgradeFlags>
+    <OldToolsVersion>2.0</OldToolsVersion>
+    <UpgradeBackupLocation>
+    </UpgradeBackupLocation>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.SGA-3.2.XML</DocumentationFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <DocumentationFile>bin\Release\HeuristicLab.SGA-3.2.XML</DocumentationFile>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <DocumentationFile>bin\Release\HeuristicLab.SGA-3.2.XML</DocumentationFile>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Windows.Forms" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="HeuristicLabSGAPlugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="SGA.cs" />
+    <Compile Include="SGAEditor.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="SGAEditor.Designer.cs">
+      <DependentUpon>SGAEditor.cs</DependentUpon>
+    </Compile>
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Constraints\3.2\HeuristicLab.Constraints-3.2.csproj">
+      <Project>{FCD62C6F-4793-4593-AE9A-0BDCA256EE99}</Project>
+      <Name>HeuristicLab.Constraints-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.2\HeuristicLab.Core-3.2.csproj">
+      <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
+      <Name>HeuristicLab.Core-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Data\3.2\HeuristicLab.Data-3.2.csproj">
+      <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
+      <Name>HeuristicLab.Data-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Evolutionary\3.2\HeuristicLab.Evolutionary-3.2.csproj">
+      <Project>{F5614C53-153C-4A37-A608-121E1C087F07}</Project>
+      <Name>HeuristicLab.Evolutionary-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Logging\3.2\HeuristicLab.Logging-3.2.csproj">
+      <Project>{4095C92C-5A4C-44BC-9963-5F384CF5CC3F}</Project>
+      <Name>HeuristicLab.Logging-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Operators\3.2\HeuristicLab.Operators-3.2.csproj">
+      <Project>{A9983BA2-B3B2-475E-8E2C-62050B71D1C5}</Project>
+      <Name>HeuristicLab.Operators-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Random\3.2\HeuristicLab.Random-3.2.csproj">
+      <Project>{47019A74-F7F7-482E-83AA-D3F4F777E879}</Project>
+      <Name>HeuristicLab.Random-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Selection\3.2\HeuristicLab.Selection-3.2.csproj">
+      <Project>{F7CF0571-25CB-43D5-8443-0843A1E2861A}</Project>
+      <Name>HeuristicLab.Selection-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.SequentialEngine\3.2\HeuristicLab.SequentialEngine-3.2.csproj">
+      <Project>{B4BE8E53-BA06-4237-9A01-24255F880201}</Project>
+      <Name>HeuristicLab.SequentialEngine-3.2</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="SGAEditor.resx">
+      <SubType>Designer</SubType>
+      <DependentUpon>SGAEditor.cs</DependentUpon>
+    </EmbeddedResource>
+  </ItemGroup>
+  <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: trunk/sources/HeuristicLab.SGA/3.3/HeuristicLabSGAPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/HeuristicLabSGAPlugin.cs	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/HeuristicLabSGAPlugin.cs	(revision 1865)
@@ -0,0 +1,43 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.SGA {
+  /// <summary>
+  /// Plugin class for HeuristicLab.SGA plugin.
+  /// </summary>
+  [ClassInfo(Name = "HeuristicLab.SGA-3.2")]
+  [PluginFile(Filename = "HeuristicLab.SGA-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Selection-3.2")]
+  [Dependency(Dependency = "HeuristicLab.Logging-3.2")]
+  [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
+  public class HeuristicLabSGAPlugin : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.SGA/3.3/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/Properties/AssemblyInfo.frame	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/Properties/AssemblyInfo.frame	(revision 1865)
@@ -0,0 +1,58 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+using HeuristicLab.PluginInfrastructure;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.SGA")]
+[assembly: AssemblyDescription("HeuristicLab Standard Genetic Algorithm (SGA)")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2008 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("ec039d68-07a5-43cf-ba26-34f41c2d470a")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyFileVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyBuildDate("$WCNOW$")]
Index: trunk/sources/HeuristicLab.SGA/3.3/SGA.cs
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/SGA.cs	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/SGA.cs	(revision 1865)
@@ -0,0 +1,611 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Evolutionary;
+using HeuristicLab.SequentialEngine;
+using HeuristicLab.Operators;
+using HeuristicLab.Random;
+using HeuristicLab.Logging;
+using HeuristicLab.Selection;
+
+namespace HeuristicLab.SGA {
+  /// <summary>
+  /// Class for the heuristic optimization technique "simple genetic algorithm".
+  /// </summary>
+  public class SGA : ItemBase, IEditable {
+    #region Create Operators
+    /// <summary>
+    /// Creates operators for the current instance.
+    /// </summary>
+    /// <param name="engine">The engine where to add the operators.</param>
+    public static void Create(IEngine engine) {
+      engine.OperatorGraph.Clear();
+
+      CombinedOperator co = CreateSGA();
+      co.Name = "SGA";
+      engine.OperatorGraph.AddOperator(co);
+      engine.OperatorGraph.InitialOperator = co;
+
+      engine.Reset();
+    }
+    private static CombinedOperator CreateSGA() {
+      CombinedOperator op = new CombinedOperator();
+      SequentialProcessor sp = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp);
+      op.OperatorGraph.InitialOperator = sp;
+
+      CombinedOperator co1 = CreateVariableInjection();
+      co1.Name = "Variable Injection";
+      op.OperatorGraph.AddOperator(co1);
+      sp.AddSubOperator(co1);
+
+      // place holder for ProblemInjector
+      EmptyOperator eo1 = new EmptyOperator();
+      eo1.Name = "ProblemInjector";
+      op.OperatorGraph.AddOperator(eo1);
+      co1.AddSubOperator(eo1);
+
+      CombinedOperator co2 = CreatePopulationInitialization();
+      co2.Name = "Population Initialization";
+      op.OperatorGraph.AddOperator(co2);
+      sp.AddSubOperator(co2);
+
+      // place holder for SolutionGenerator
+      EmptyOperator eo2 = new EmptyOperator();
+      eo2.Name = "SolutionGenerator";
+      op.OperatorGraph.AddOperator(eo2);
+      co2.AddSubOperator(eo2);
+
+      // place holder for Evaluator
+      EmptyOperator eo3 = new EmptyOperator();
+      eo3.Name = "Evaluator";
+      op.OperatorGraph.AddOperator(eo3);
+      co2.AddSubOperator(eo3);
+
+      CombinedOperator co3 = CreateSGAMain();
+      co3.Name = "SGA Main";
+      op.OperatorGraph.AddOperator(co3);
+      sp.AddSubOperator(co3);
+
+      // place holder for Selector
+      EmptyOperator eo4 = new EmptyOperator();
+      eo4.Name = "Selector";
+      op.OperatorGraph.AddOperator(eo4);
+      co3.AddSubOperator(eo4);
+
+      // place holder for Crossover
+      EmptyOperator eo5 = new EmptyOperator();
+      eo5.Name = "Crossover";
+      op.OperatorGraph.AddOperator(eo5);
+      co3.AddSubOperator(eo5);
+
+      // place holder for Mutator
+      EmptyOperator eo6 = new EmptyOperator();
+      eo6.Name = "Mutator";
+      op.OperatorGraph.AddOperator(eo6);
+      co3.AddSubOperator(eo6);
+
+      // place holder for Evaluator
+      co3.AddSubOperator(eo3);
+
+      return op;
+    }
+    private static CombinedOperator CreateVariableInjection() {
+      CombinedOperator op = new CombinedOperator();
+      SequentialProcessor sp = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp);
+      op.OperatorGraph.InitialOperator = sp;
+
+      RandomInjector ri = new RandomInjector();
+      op.OperatorGraph.AddOperator(ri);
+      sp.AddSubOperator(ri);
+
+      OperatorExtractor oe = new OperatorExtractor();
+      oe.Name = "ProblemInjector";
+      oe.GetVariableInfo("Operator").ActualName = "ProblemInjector";
+      op.OperatorGraph.AddOperator(oe);
+      sp.AddSubOperator(oe);
+
+      VariableInjector vi = new VariableInjector();
+      vi.AddVariable(new Variable("PopulationSize", new IntData(100)));
+      vi.AddVariable(new Variable("EvaluatedSolutions", new IntData()));
+      vi.AddVariable(new Variable("Parents", new IntData(200)));
+      vi.AddVariable(new Variable("MutationRate", new DoubleData(0.05)));
+      vi.AddVariable(new Variable("Elites", new IntData(1)));
+      vi.AddVariable(new Variable("Generations", new IntData()));
+      vi.AddVariable(new Variable("MaximumGenerations", new IntData(1000)));
+      op.OperatorGraph.AddOperator(vi);
+      sp.AddSubOperator(vi);
+
+      return op;
+    }
+    private static CombinedOperator CreatePopulationInitialization() {
+      CombinedOperator op = new CombinedOperator();
+      SequentialProcessor sp1 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp1);
+      op.OperatorGraph.InitialOperator = sp1;
+
+      SubScopesCreater ssc = new SubScopesCreater();
+      ssc.GetVariableInfo("SubScopes").ActualName = "PopulationSize";
+      op.OperatorGraph.AddOperator(ssc);
+      sp1.AddSubOperator(ssc);
+
+      UniformSequentialSubScopesProcessor ussp = new UniformSequentialSubScopesProcessor();
+      op.OperatorGraph.AddOperator(ussp);
+      sp1.AddSubOperator(ussp);
+
+      SequentialProcessor sp2 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp2);
+      ussp.AddSubOperator(sp2);
+
+      OperatorExtractor oe1 = new OperatorExtractor();
+      oe1.Name = "SolutionGenerator";
+      oe1.GetVariableInfo("Operator").ActualName = "SolutionGenerator";
+      op.OperatorGraph.AddOperator(oe1);
+      sp2.AddSubOperator(oe1);
+
+      OperatorExtractor oe2 = new OperatorExtractor();
+      oe2.Name = "Evaluator";
+      oe2.GetVariableInfo("Operator").ActualName = "Evaluator";
+      op.OperatorGraph.AddOperator(oe2);
+      sp2.AddSubOperator(oe2);
+
+      Counter c = new Counter();
+      c.GetVariableInfo("Value").ActualName = "EvaluatedSolutions";
+      op.OperatorGraph.AddOperator(c);
+      sp2.AddSubOperator(c);
+
+      Sorter s = new Sorter();
+      s.GetVariableInfo("Descending").ActualName = "Maximization";
+      s.GetVariableInfo("Value").ActualName = "Quality";
+      op.OperatorGraph.AddOperator(s);
+      sp1.AddSubOperator(s);
+
+      return op;
+    }
+    private static CombinedOperator CreateSGAMain() {
+      CombinedOperator op = new CombinedOperator();
+      SequentialProcessor sp = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp);
+      op.OperatorGraph.InitialOperator = sp;
+
+      OperatorExtractor oe = new OperatorExtractor();
+      oe.Name = "Selector";
+      oe.GetVariableInfo("Operator").ActualName = "Selector";
+      op.OperatorGraph.AddOperator(oe);
+      sp.AddSubOperator(oe);
+
+      SequentialSubScopesProcessor ssp = new SequentialSubScopesProcessor();
+      op.OperatorGraph.AddOperator(ssp);
+      sp.AddSubOperator(ssp);
+
+      EmptyOperator eo = new EmptyOperator();
+      op.OperatorGraph.AddOperator(eo);
+      ssp.AddSubOperator(eo);
+
+      CombinedOperator co1 = CreateCreateChildren();
+      co1.Name = "Create Children";
+      op.OperatorGraph.AddOperator(co1);
+      ssp.AddSubOperator(co1);
+
+      CombinedOperator co2 = CreateReplacement();
+      co2.Name = "Replacement";
+      op.OperatorGraph.AddOperator(co2);
+      sp.AddSubOperator(co2);
+
+      QualityLogger ql = new QualityLogger();
+      op.OperatorGraph.AddOperator(ql);
+      sp.AddSubOperator(ql);
+
+      BestAverageWorstQualityCalculator bawqc = new BestAverageWorstQualityCalculator();
+      op.OperatorGraph.AddOperator(bawqc);
+      sp.AddSubOperator(bawqc);
+
+      DataCollector dc = new DataCollector();
+      ItemList<StringData> names = dc.GetVariable("VariableNames").GetValue<ItemList<StringData>>();
+      names.Add(new StringData("BestQuality"));
+      names.Add(new StringData("AverageQuality"));
+      names.Add(new StringData("WorstQuality"));
+      op.OperatorGraph.AddOperator(dc);
+      sp.AddSubOperator(dc);
+
+      LinechartInjector lci = new LinechartInjector();
+      lci.GetVariableInfo("Linechart").ActualName = "Quality Linechart";
+      lci.GetVariable("NumberOfLines").GetValue<IntData>().Data = 3;
+      op.OperatorGraph.AddOperator(lci);
+      sp.AddSubOperator(lci);
+
+      Counter c = new Counter();
+      c.GetVariableInfo("Value").ActualName = "Generations";
+      op.OperatorGraph.AddOperator(c);
+      sp.AddSubOperator(c);
+
+      LessThanComparator ltc = new LessThanComparator();
+      ltc.GetVariableInfo("LeftSide").ActualName = "Generations";
+      ltc.GetVariableInfo("RightSide").ActualName = "MaximumGenerations";
+      ltc.GetVariableInfo("Result").ActualName = "GenerationsCondition";
+      op.OperatorGraph.AddOperator(ltc);
+      sp.AddSubOperator(ltc);
+
+      ConditionalBranch cb = new ConditionalBranch();
+      cb.GetVariableInfo("Condition").ActualName = "GenerationsCondition";
+      op.OperatorGraph.AddOperator(cb);
+      sp.AddSubOperator(cb);
+
+      cb.AddSubOperator(sp);
+
+      return op;
+    }
+    private static CombinedOperator CreateCreateChildren() {
+      CombinedOperator op = new CombinedOperator();
+      SequentialProcessor sp1 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp1);
+      op.OperatorGraph.InitialOperator = sp1;
+
+      ChildrenInitializer ci = new ChildrenInitializer();
+      op.OperatorGraph.AddOperator(ci);
+      sp1.AddSubOperator(ci);
+
+      UniformSequentialSubScopesProcessor ussp = new UniformSequentialSubScopesProcessor();
+      op.OperatorGraph.AddOperator(ussp);
+      sp1.AddSubOperator(ussp);
+
+      SequentialProcessor sp2 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp2);
+      ussp.AddSubOperator(sp2);
+
+      OperatorExtractor oe1 = new OperatorExtractor();
+      oe1.Name = "Crossover";
+      oe1.GetVariableInfo("Operator").ActualName = "Crossover";
+      op.OperatorGraph.AddOperator(oe1);
+      sp2.AddSubOperator(oe1);
+
+      StochasticBranch hb = new StochasticBranch();
+      hb.GetVariableInfo("Probability").ActualName = "MutationRate";
+      op.OperatorGraph.AddOperator(hb);
+      sp2.AddSubOperator(hb);
+
+      OperatorExtractor oe2 = new OperatorExtractor();
+      oe2.Name = "Mutator";
+      oe2.GetVariableInfo("Operator").ActualName = "Mutator";
+      op.OperatorGraph.AddOperator(oe2);
+      hb.AddSubOperator(oe2);
+
+      OperatorExtractor oe3 = new OperatorExtractor();
+      oe3.Name = "Evaluator";
+      oe3.GetVariableInfo("Operator").ActualName = "Evaluator";
+      op.OperatorGraph.AddOperator(oe3);
+      sp2.AddSubOperator(oe3);
+
+      SubScopesRemover sr = new SubScopesRemover();
+      sr.GetVariableInfo("SubScopeIndex").Local = true;
+      op.OperatorGraph.AddOperator(sr);
+      sp2.AddSubOperator(sr);
+
+      Counter c = new Counter();
+      c.GetVariableInfo("Value").ActualName = "EvaluatedSolutions";
+      op.OperatorGraph.AddOperator(c);
+      sp2.AddSubOperator(c);
+
+      Sorter s = new Sorter();
+      s.GetVariableInfo("Descending").ActualName = "Maximization";
+      s.GetVariableInfo("Value").ActualName = "Quality";
+      op.OperatorGraph.AddOperator(s);
+      sp1.AddSubOperator(s);
+
+      return op;
+    }
+    private static CombinedOperator CreateReplacement() {
+      CombinedOperator op = new CombinedOperator();
+      SequentialProcessor sp1 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp1);
+      op.OperatorGraph.InitialOperator = sp1;
+
+      SequentialSubScopesProcessor ssp = new SequentialSubScopesProcessor();
+      op.OperatorGraph.AddOperator(ssp);
+      sp1.AddSubOperator(ssp);
+
+      SequentialProcessor sp2 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp2);
+      ssp.AddSubOperator(sp2);
+
+      LeftSelector ls = new LeftSelector();
+      ls.GetVariableInfo("Selected").ActualName = "Elites";
+      op.OperatorGraph.AddOperator(ls);
+      sp2.AddSubOperator(ls);
+
+      RightReducer rr = new RightReducer();
+      op.OperatorGraph.AddOperator(rr);
+      sp2.AddSubOperator(rr);
+
+      SequentialProcessor sp3 = new SequentialProcessor();
+      op.OperatorGraph.AddOperator(sp3);
+      ssp.AddSubOperator(sp3);
+
+      RightSelector rs = new RightSelector();
+      rs.GetVariableInfo("Selected").ActualName = "Elites";
+      op.OperatorGraph.AddOperator(rs);
+      sp3.AddSubOperator(rs);
+
+      LeftReducer lr = new LeftReducer();
+      op.OperatorGraph.AddOperator(lr);
+      sp3.AddSubOperator(lr);
+
+      MergingReducer mr = new MergingReducer();
+      op.OperatorGraph.AddOperator(mr);
+      sp1.AddSubOperator(mr);
+
+      Sorter s = new Sorter();
+      s.GetVariableInfo("Descending").ActualName = "Maximization";
+      s.GetVariableInfo("Value").ActualName = "Quality";
+      op.OperatorGraph.AddOperator(s);
+      sp1.AddSubOperator(s);
+
+      return op;
+    }
+    #endregion
+
+    #region Properties
+    private IEngine myEngine;
+    /// <summary>
+    /// Gets the engine of the current instance.
+    /// </summary>
+    public IEngine Engine {
+      get { return myEngine; }
+    }
+    private BoolData mySetSeedRandomly;
+    /// <summary>
+    /// Gets or sets the flag whether to set the seed randomly or not.
+    /// </summary>
+    public bool SetSeedRandomly {
+      get { return mySetSeedRandomly.Data; }
+      set { mySetSeedRandomly.Data = value; }
+    }
+    private IntData mySeed;
+    /// <summary>
+    /// Gets or sets the value of the seed of the current instance.
+    /// </summary>
+    public int Seed {
+      get { return mySeed.Data; }
+      set { mySeed.Data = value; }
+    }
+    private IntData myPopulationSize;
+    private IntData myParents;
+    /// <summary>
+    /// Gets or sets the population size of the current instance.
+    /// </summary>
+    /// <remarks>The number of parents is set to two times the population size.</remarks>
+    public int PopulationSize {
+      get { return myPopulationSize.Data; }
+      set {
+        myPopulationSize.Data = value;
+        myParents.Data = value * 2;
+      }
+    }
+    private IntData myMaximumGenerations;
+    /// <summary>
+    /// Gets or sets the number of maximum generations.
+    /// </summary>
+    public int MaximumGenerations {
+      get { return myMaximumGenerations.Data; }
+      set { myMaximumGenerations.Data = value; }
+    }
+    private DoubleData myMutationRate;
+    /// <summary>
+    /// Gets or sets the mutation rate of the current instance.
+    /// </summary>
+    public double MutationRate {
+      get { return myMutationRate.Data; }
+      set { myMutationRate.Data = value; }
+    }
+    private IntData myElites;
+    /// <summary>
+    /// Gets or sets the elites of the current instance.
+    /// </summary>
+    public int Elites {
+      get { return myElites.Data; }
+      set { myElites.Data = value; }
+    }
+    private CombinedOperator mySGA;
+    private IOperator myVariableInjection;
+    /// <summary>
+    /// Gets or sets the problem injector of the current instance.
+    /// </summary>
+    public IOperator ProblemInjector {
+      get { return myVariableInjection.SubOperators[0]; }
+      set {
+        value.Name = "ProblemInjector";
+        mySGA.OperatorGraph.RemoveOperator(ProblemInjector.Guid);
+        mySGA.OperatorGraph.AddOperator(value);
+        myVariableInjection.AddSubOperator(value, 0);
+      }
+    }
+    private IOperator myPopulationInitialization;
+    /// <summary>
+    /// Gets or sets the solution generator of the current instance.
+    /// </summary>
+    public IOperator SolutionGenerator {
+      get { return myPopulationInitialization.SubOperators[0]; }
+      set {
+        value.Name = "SolutionGenerator";
+        mySGA.OperatorGraph.RemoveOperator(SolutionGenerator.Guid);
+        mySGA.OperatorGraph.AddOperator(value);
+        myPopulationInitialization.AddSubOperator(value, 0);
+      }
+    }
+    /// <summary>
+    /// Gets or sets the evaluator of the current instance.
+    /// </summary>
+    public IOperator Evaluator {
+      get { return myPopulationInitialization.SubOperators[1]; }
+      set {
+        value.Name = "Evaluator";
+        mySGA.OperatorGraph.RemoveOperator(Evaluator.Guid);
+        mySGA.OperatorGraph.AddOperator(value);
+        myPopulationInitialization.AddSubOperator(value, 1);
+        mySGAMain.AddSubOperator(value, 3);
+      }
+    }
+    private IOperator mySGAMain;
+    /// <summary>
+    /// Gets or sets the selection operator of the current instance.
+    /// </summary>
+    public IOperator Selector {
+      get { return mySGAMain.SubOperators[0]; }
+      set {
+        value.Name = "Selector";
+        mySGA.OperatorGraph.RemoveOperator(Selector.Guid);
+        mySGA.OperatorGraph.AddOperator(value);
+        mySGAMain.AddSubOperator(value, 0);
+      }
+    }
+    /// <summary>
+    /// Gets or sets the crossover operator of the current instance.
+    /// </summary>
+    public IOperator Crossover {
+      get { return mySGAMain.SubOperators[1]; }
+      set {
+        value.Name = "Crossover";
+        mySGA.OperatorGraph.RemoveOperator(Crossover.Guid);
+        mySGA.OperatorGraph.AddOperator(value);
+        mySGAMain.AddSubOperator(value, 1);
+      }
+    }
+    /// <summary>
+    /// Gets or sets the mutation operator of the current instance.
+    /// </summary>
+    public IOperator Mutator {
+      get { return mySGAMain.SubOperators[2]; }
+      set {
+        value.Name = "Mutator";
+        mySGA.OperatorGraph.RemoveOperator(Mutator.Guid);
+        mySGA.OperatorGraph.AddOperator(value);
+        mySGAMain.AddSubOperator(value, 2);
+      }
+    }
+    #endregion
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="SGA"/>.
+    /// </summary>
+    public SGA() {
+      myEngine = new SequentialEngine.SequentialEngine();
+      Create(myEngine);
+      SetReferences();
+    }
+
+    /// <summary>
+    /// Creates a new instance of the <see cref="SGAEditor"/> class.
+    /// </summary>
+    /// <returns>The created instance of the <see cref="SGAEditor"/>.</returns>
+    public override IView CreateView() {
+      return new SGAEditor(this);
+    }
+    /// <summary>
+    /// Creates a new instance of the <see cref="SGAEditor"/> class.
+    /// </summary>
+    /// <returns>The created instance of the <see cref="SGAEditor"/>.</returns>
+    public virtual IEditor CreateEditor() {
+      return new SGAEditor(this);
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Deep clone through <see cref="Auxiliary.Clone"/> method of helper class 
+    /// <see cref="Auxiliary"/>.</remarks>
+    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="SGA"/>.</returns>
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      SGA clone = new SGA();
+      clonedObjects.Add(Guid, clone);
+      clone.myEngine = (IEngine)Auxiliary.Clone(Engine, clonedObjects);
+      return clone;
+    }
+
+    #region SetReferences Method
+    private void SetReferences() {
+      // SGA
+      CombinedOperator co1 = (CombinedOperator)Engine.OperatorGraph.InitialOperator;
+      mySGA = co1;
+      // SequentialProcessor in SGA
+      SequentialProcessor sp1 = (SequentialProcessor)co1.OperatorGraph.InitialOperator;
+      // Variable Injection
+      CombinedOperator co2 = (CombinedOperator)sp1.SubOperators[0];
+      myVariableInjection = co2;
+      // SequentialProcessor in Variable Injection
+      SequentialProcessor sp2 = (SequentialProcessor)co2.OperatorGraph.InitialOperator;
+      // RandomInjector
+      RandomInjector ri = (RandomInjector)sp2.SubOperators[0];
+      mySetSeedRandomly = ri.GetVariable("SetSeedRandomly").GetValue<BoolData>();
+      mySeed = ri.GetVariable("Seed").GetValue<IntData>();
+      // VariableInjector
+      VariableInjector vi = (VariableInjector)sp2.SubOperators[2];
+      myPopulationSize = vi.GetVariable("PopulationSize").GetValue<IntData>();
+      myParents = vi.GetVariable("Parents").GetValue<IntData>();
+      myMaximumGenerations = vi.GetVariable("MaximumGenerations").GetValue<IntData>();
+      myMutationRate = vi.GetVariable("MutationRate").GetValue<DoubleData>();
+      myElites = vi.GetVariable("Elites").GetValue<IntData>();
+      // Population Initialization
+      CombinedOperator co3 = (CombinedOperator)sp1.SubOperators[1];
+      myPopulationInitialization = co3;
+      // SGA Main
+      CombinedOperator co4 = (CombinedOperator)sp1.SubOperators[2];
+      mySGAMain = co4;
+    }
+    #endregion
+
+    #region Persistence Methods
+    /// <summary>
+    /// Saves the current instance as <see cref="XmlNode"/> in the specified <paramref name="document"/>.
+    /// </summary>
+    /// <remarks>The engine of the current instance is saved as a child node with the tag name 
+    /// <c>Engine</c>.</remarks>
+    /// <param name="name">The (tag)name of the <see cref="XmlNode"/>.</param>
+    /// <param name="document">The <see cref="XmlDocument"/> where the data is saved.</param>
+    /// <param name="persistedObjects">A dictionary of all already persisted objects. (Needed to avoid cycles.)</param>
+    /// <returns>The saved <see cref="XmlNode"/>.</returns>
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid,IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+      node.AppendChild(PersistenceManager.Persist("Engine", Engine, document, persistedObjects));
+      return node;
+    }
+    /// <summary>
+    /// Loads the persisted instance from the specified <paramref name="node"/>.
+    /// </summary>
+    /// <remarks>The elements of the current instance must be saved in a special way, see 
+    /// <see cref="GetXmlNode"/>.</remarks>
+    /// <param name="node">The <see cref="XmlNode"/> where the instance is saved.</param>
+    /// <param name="restoredObjects">The dictionary of all already restored objects. (Needed to avoid cycles.)</param>
+    public override void Populate(XmlNode node, IDictionary<Guid,IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+      myEngine = (IEngine)PersistenceManager.Restore(node.SelectSingleNode("Engine"), restoredObjects);
+      SetReferences();
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.Designer.cs	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.Designer.cs	(revision 1865)
@@ -0,0 +1,644 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.SGA {
+  partial class SGAEditor {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (chooseOperatorDialog != null) chooseOperatorDialog.Dispose();
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.executeButton = new System.Windows.Forms.Button();
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.parametersTabPage = new System.Windows.Forms.TabPage();
+      this.setEvaluationButton = new System.Windows.Forms.Button();
+      this.setMutationButton = new System.Windows.Forms.Button();
+      this.setCrossoverButton = new System.Windows.Forms.Button();
+      this.setSelectionButton = new System.Windows.Forms.Button();
+      this.setSolutionGenerationButton = new System.Windows.Forms.Button();
+      this.setProblemInitializationButton = new System.Windows.Forms.Button();
+      this.evaluationTextBox = new System.Windows.Forms.TextBox();
+      this.mutationTextBox = new System.Windows.Forms.TextBox();
+      this.crossoverTextBox = new System.Windows.Forms.TextBox();
+      this.selectionTextBox = new System.Windows.Forms.TextBox();
+      this.solutionGenerationTextBox = new System.Windows.Forms.TextBox();
+      this.problemInitializationTextBox = new System.Windows.Forms.TextBox();
+      this.setRandomSeedRandomlyCheckBox = new System.Windows.Forms.CheckBox();
+      this.elitesTextBox = new System.Windows.Forms.TextBox();
+      this.evaluationLabel = new System.Windows.Forms.Label();
+      this.mutationLabel = new System.Windows.Forms.Label();
+      this.selectionLabel = new System.Windows.Forms.Label();
+      this.crossoverLabel = new System.Windows.Forms.Label();
+      this.solutionGenerationLabel = new System.Windows.Forms.Label();
+      this.problemInitializationLabel = new System.Windows.Forms.Label();
+      this.elitesLabel = new System.Windows.Forms.Label();
+      this.mutationRateTextBox = new System.Windows.Forms.TextBox();
+      this.mutationRateLabel = new System.Windows.Forms.Label();
+      this.maximumGenerationsTextBox = new System.Windows.Forms.TextBox();
+      this.maximumGenerationsLabel = new System.Windows.Forms.Label();
+      this.randomSeedTextBox = new System.Windows.Forms.TextBox();
+      this.populationSizeTextBox = new System.Windows.Forms.TextBox();
+      this.setRandomSeedRandomlyLabel = new System.Windows.Forms.Label();
+      this.randomSeedLabel = new System.Windows.Forms.Label();
+      this.populationSizeLabel = new System.Windows.Forms.Label();
+      this.scopesTabPage = new System.Windows.Forms.TabPage();
+      this.scopeView = new HeuristicLab.Core.ScopeView();
+      this.abortButton = new System.Windows.Forms.Button();
+      this.resetButton = new System.Windows.Forms.Button();
+      this.cloneEngineButton = new System.Windows.Forms.Button();
+      this.viewProblemInitializationButton = new System.Windows.Forms.Button();
+      this.viewSolutionGenerationButton = new System.Windows.Forms.Button();
+      this.viewSelectionButton = new System.Windows.Forms.Button();
+      this.viewCrossoverButton = new System.Windows.Forms.Button();
+      this.viewMutationButton = new System.Windows.Forms.Button();
+      this.viewEvaluationButton = new System.Windows.Forms.Button();
+      this.tabControl.SuspendLayout();
+      this.parametersTabPage.SuspendLayout();
+      this.scopesTabPage.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // executeButton
+      // 
+      this.executeButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.executeButton.Location = new System.Drawing.Point(0, 396);
+      this.executeButton.Name = "executeButton";
+      this.executeButton.Size = new System.Drawing.Size(75, 23);
+      this.executeButton.TabIndex = 1;
+      this.executeButton.Text = "&Execute";
+      this.executeButton.UseVisualStyleBackColor = true;
+      this.executeButton.Click += new System.EventHandler(this.executeButton_Click);
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.parametersTabPage);
+      this.tabControl.Controls.Add(this.scopesTabPage);
+      this.tabControl.Location = new System.Drawing.Point(0, 0);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(526, 390);
+      this.tabControl.TabIndex = 0;
+      // 
+      // parametersTabPage
+      // 
+      this.parametersTabPage.Controls.Add(this.setEvaluationButton);
+      this.parametersTabPage.Controls.Add(this.setMutationButton);
+      this.parametersTabPage.Controls.Add(this.setCrossoverButton);
+      this.parametersTabPage.Controls.Add(this.setSelectionButton);
+      this.parametersTabPage.Controls.Add(this.setSolutionGenerationButton);
+      this.parametersTabPage.Controls.Add(this.viewEvaluationButton);
+      this.parametersTabPage.Controls.Add(this.viewMutationButton);
+      this.parametersTabPage.Controls.Add(this.viewCrossoverButton);
+      this.parametersTabPage.Controls.Add(this.viewSelectionButton);
+      this.parametersTabPage.Controls.Add(this.viewSolutionGenerationButton);
+      this.parametersTabPage.Controls.Add(this.viewProblemInitializationButton);
+      this.parametersTabPage.Controls.Add(this.setProblemInitializationButton);
+      this.parametersTabPage.Controls.Add(this.evaluationTextBox);
+      this.parametersTabPage.Controls.Add(this.mutationTextBox);
+      this.parametersTabPage.Controls.Add(this.crossoverTextBox);
+      this.parametersTabPage.Controls.Add(this.selectionTextBox);
+      this.parametersTabPage.Controls.Add(this.solutionGenerationTextBox);
+      this.parametersTabPage.Controls.Add(this.problemInitializationTextBox);
+      this.parametersTabPage.Controls.Add(this.setRandomSeedRandomlyCheckBox);
+      this.parametersTabPage.Controls.Add(this.elitesTextBox);
+      this.parametersTabPage.Controls.Add(this.evaluationLabel);
+      this.parametersTabPage.Controls.Add(this.mutationLabel);
+      this.parametersTabPage.Controls.Add(this.selectionLabel);
+      this.parametersTabPage.Controls.Add(this.crossoverLabel);
+      this.parametersTabPage.Controls.Add(this.solutionGenerationLabel);
+      this.parametersTabPage.Controls.Add(this.problemInitializationLabel);
+      this.parametersTabPage.Controls.Add(this.elitesLabel);
+      this.parametersTabPage.Controls.Add(this.mutationRateTextBox);
+      this.parametersTabPage.Controls.Add(this.mutationRateLabel);
+      this.parametersTabPage.Controls.Add(this.maximumGenerationsTextBox);
+      this.parametersTabPage.Controls.Add(this.maximumGenerationsLabel);
+      this.parametersTabPage.Controls.Add(this.randomSeedTextBox);
+      this.parametersTabPage.Controls.Add(this.populationSizeTextBox);
+      this.parametersTabPage.Controls.Add(this.setRandomSeedRandomlyLabel);
+      this.parametersTabPage.Controls.Add(this.randomSeedLabel);
+      this.parametersTabPage.Controls.Add(this.populationSizeLabel);
+      this.parametersTabPage.Location = new System.Drawing.Point(4, 22);
+      this.parametersTabPage.Name = "parametersTabPage";
+      this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.parametersTabPage.Size = new System.Drawing.Size(518, 364);
+      this.parametersTabPage.TabIndex = 0;
+      this.parametersTabPage.Text = "Parameters";
+      this.parametersTabPage.UseVisualStyleBackColor = true;
+      // 
+      // setEvaluationButton
+      // 
+      this.setEvaluationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setEvaluationButton.Location = new System.Drawing.Point(469, 338);
+      this.setEvaluationButton.Name = "setEvaluationButton";
+      this.setEvaluationButton.Size = new System.Drawing.Size(43, 20);
+      this.setEvaluationButton.TabIndex = 35;
+      this.setEvaluationButton.Text = "Set...";
+      this.setEvaluationButton.UseVisualStyleBackColor = true;
+      this.setEvaluationButton.Click += new System.EventHandler(this.setEvaluationButton_Click);
+      // 
+      // setMutationButton
+      // 
+      this.setMutationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setMutationButton.Location = new System.Drawing.Point(469, 312);
+      this.setMutationButton.Name = "setMutationButton";
+      this.setMutationButton.Size = new System.Drawing.Size(43, 20);
+      this.setMutationButton.TabIndex = 31;
+      this.setMutationButton.Text = "Set...";
+      this.setMutationButton.UseVisualStyleBackColor = true;
+      this.setMutationButton.Click += new System.EventHandler(this.setMutationButton_Click);
+      // 
+      // setCrossoverButton
+      // 
+      this.setCrossoverButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setCrossoverButton.Location = new System.Drawing.Point(469, 286);
+      this.setCrossoverButton.Name = "setCrossoverButton";
+      this.setCrossoverButton.Size = new System.Drawing.Size(43, 20);
+      this.setCrossoverButton.TabIndex = 27;
+      this.setCrossoverButton.Text = "Set...";
+      this.setCrossoverButton.UseVisualStyleBackColor = true;
+      this.setCrossoverButton.Click += new System.EventHandler(this.setCrossoverButton_Click);
+      // 
+      // setSelectionButton
+      // 
+      this.setSelectionButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setSelectionButton.Location = new System.Drawing.Point(469, 260);
+      this.setSelectionButton.Name = "setSelectionButton";
+      this.setSelectionButton.Size = new System.Drawing.Size(43, 20);
+      this.setSelectionButton.TabIndex = 23;
+      this.setSelectionButton.Text = "Set...";
+      this.setSelectionButton.UseVisualStyleBackColor = true;
+      this.setSelectionButton.Click += new System.EventHandler(this.setSelectionButton_Click);
+      // 
+      // setSolutionGenerationButton
+      // 
+      this.setSolutionGenerationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setSolutionGenerationButton.Location = new System.Drawing.Point(469, 234);
+      this.setSolutionGenerationButton.Name = "setSolutionGenerationButton";
+      this.setSolutionGenerationButton.Size = new System.Drawing.Size(43, 20);
+      this.setSolutionGenerationButton.TabIndex = 19;
+      this.setSolutionGenerationButton.Text = "Set...";
+      this.setSolutionGenerationButton.UseVisualStyleBackColor = true;
+      this.setSolutionGenerationButton.Click += new System.EventHandler(this.setSolutionGenerationButton_Click);
+      // 
+      // setProblemInitializationButton
+      // 
+      this.setProblemInitializationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setProblemInitializationButton.Location = new System.Drawing.Point(469, 208);
+      this.setProblemInitializationButton.Name = "setProblemInitializationButton";
+      this.setProblemInitializationButton.Size = new System.Drawing.Size(43, 20);
+      this.setProblemInitializationButton.TabIndex = 15;
+      this.setProblemInitializationButton.Text = "Set...";
+      this.setProblemInitializationButton.UseVisualStyleBackColor = true;
+      this.setProblemInitializationButton.Click += new System.EventHandler(this.setProblemInitializationButton_Click);
+      // 
+      // evaluationTextBox
+      // 
+      this.evaluationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.evaluationTextBox.Location = new System.Drawing.Point(218, 338);
+      this.evaluationTextBox.Name = "evaluationTextBox";
+      this.evaluationTextBox.ReadOnly = true;
+      this.evaluationTextBox.Size = new System.Drawing.Size(186, 20);
+      this.evaluationTextBox.TabIndex = 33;
+      // 
+      // mutationTextBox
+      // 
+      this.mutationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.mutationTextBox.Location = new System.Drawing.Point(218, 312);
+      this.mutationTextBox.Name = "mutationTextBox";
+      this.mutationTextBox.ReadOnly = true;
+      this.mutationTextBox.Size = new System.Drawing.Size(186, 20);
+      this.mutationTextBox.TabIndex = 29;
+      // 
+      // crossoverTextBox
+      // 
+      this.crossoverTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.crossoverTextBox.Location = new System.Drawing.Point(218, 286);
+      this.crossoverTextBox.Name = "crossoverTextBox";
+      this.crossoverTextBox.ReadOnly = true;
+      this.crossoverTextBox.Size = new System.Drawing.Size(186, 20);
+      this.crossoverTextBox.TabIndex = 25;
+      // 
+      // selectionTextBox
+      // 
+      this.selectionTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.selectionTextBox.Location = new System.Drawing.Point(218, 260);
+      this.selectionTextBox.Name = "selectionTextBox";
+      this.selectionTextBox.ReadOnly = true;
+      this.selectionTextBox.Size = new System.Drawing.Size(186, 20);
+      this.selectionTextBox.TabIndex = 21;
+      // 
+      // solutionGenerationTextBox
+      // 
+      this.solutionGenerationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.solutionGenerationTextBox.Location = new System.Drawing.Point(218, 234);
+      this.solutionGenerationTextBox.Name = "solutionGenerationTextBox";
+      this.solutionGenerationTextBox.ReadOnly = true;
+      this.solutionGenerationTextBox.Size = new System.Drawing.Size(186, 20);
+      this.solutionGenerationTextBox.TabIndex = 17;
+      // 
+      // problemInitializationTextBox
+      // 
+      this.problemInitializationTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.problemInitializationTextBox.Location = new System.Drawing.Point(218, 208);
+      this.problemInitializationTextBox.Name = "problemInitializationTextBox";
+      this.problemInitializationTextBox.ReadOnly = true;
+      this.problemInitializationTextBox.Size = new System.Drawing.Size(186, 20);
+      this.problemInitializationTextBox.TabIndex = 13;
+      // 
+      // setRandomSeedRandomlyCheckBox
+      // 
+      this.setRandomSeedRandomlyCheckBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setRandomSeedRandomlyCheckBox.AutoSize = true;
+      this.setRandomSeedRandomlyCheckBox.Location = new System.Drawing.Point(218, 6);
+      this.setRandomSeedRandomlyCheckBox.Name = "setRandomSeedRandomlyCheckBox";
+      this.setRandomSeedRandomlyCheckBox.Size = new System.Drawing.Size(15, 14);
+      this.setRandomSeedRandomlyCheckBox.TabIndex = 1;
+      this.setRandomSeedRandomlyCheckBox.UseVisualStyleBackColor = true;
+      // 
+      // elitesTextBox
+      // 
+      this.elitesTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.elitesTextBox.Location = new System.Drawing.Point(218, 156);
+      this.elitesTextBox.Name = "elitesTextBox";
+      this.elitesTextBox.Size = new System.Drawing.Size(186, 20);
+      this.elitesTextBox.TabIndex = 11;
+      // 
+      // evaluationLabel
+      // 
+      this.evaluationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.evaluationLabel.AutoSize = true;
+      this.evaluationLabel.Location = new System.Drawing.Point(65, 341);
+      this.evaluationLabel.Name = "evaluationLabel";
+      this.evaluationLabel.Size = new System.Drawing.Size(60, 13);
+      this.evaluationLabel.TabIndex = 32;
+      this.evaluationLabel.Text = "&Evaluation:";
+      // 
+      // mutationLabel
+      // 
+      this.mutationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.mutationLabel.AutoSize = true;
+      this.mutationLabel.Location = new System.Drawing.Point(65, 315);
+      this.mutationLabel.Name = "mutationLabel";
+      this.mutationLabel.Size = new System.Drawing.Size(51, 13);
+      this.mutationLabel.TabIndex = 28;
+      this.mutationLabel.Text = "&Mutation:";
+      // 
+      // selectionLabel
+      // 
+      this.selectionLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.selectionLabel.AutoSize = true;
+      this.selectionLabel.Location = new System.Drawing.Point(65, 263);
+      this.selectionLabel.Name = "selectionLabel";
+      this.selectionLabel.Size = new System.Drawing.Size(54, 13);
+      this.selectionLabel.TabIndex = 20;
+      this.selectionLabel.Text = "&Selection:";
+      // 
+      // crossoverLabel
+      // 
+      this.crossoverLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.crossoverLabel.AutoSize = true;
+      this.crossoverLabel.Location = new System.Drawing.Point(65, 289);
+      this.crossoverLabel.Name = "crossoverLabel";
+      this.crossoverLabel.Size = new System.Drawing.Size(57, 13);
+      this.crossoverLabel.TabIndex = 24;
+      this.crossoverLabel.Text = "&Crossover:";
+      // 
+      // solutionGenerationLabel
+      // 
+      this.solutionGenerationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.solutionGenerationLabel.AutoSize = true;
+      this.solutionGenerationLabel.Location = new System.Drawing.Point(65, 237);
+      this.solutionGenerationLabel.Name = "solutionGenerationLabel";
+      this.solutionGenerationLabel.Size = new System.Drawing.Size(103, 13);
+      this.solutionGenerationLabel.TabIndex = 16;
+      this.solutionGenerationLabel.Text = "&Solution Generation:";
+      // 
+      // problemInitializationLabel
+      // 
+      this.problemInitializationLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.problemInitializationLabel.AutoSize = true;
+      this.problemInitializationLabel.Location = new System.Drawing.Point(65, 211);
+      this.problemInitializationLabel.Name = "problemInitializationLabel";
+      this.problemInitializationLabel.Size = new System.Drawing.Size(105, 13);
+      this.problemInitializationLabel.TabIndex = 12;
+      this.problemInitializationLabel.Text = "&Problem Initialization:";
+      // 
+      // elitesLabel
+      // 
+      this.elitesLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.elitesLabel.AutoSize = true;
+      this.elitesLabel.Location = new System.Drawing.Point(65, 159);
+      this.elitesLabel.Name = "elitesLabel";
+      this.elitesLabel.Size = new System.Drawing.Size(35, 13);
+      this.elitesLabel.TabIndex = 10;
+      this.elitesLabel.Text = "&Elites:";
+      // 
+      // mutationRateTextBox
+      // 
+      this.mutationRateTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.mutationRateTextBox.Location = new System.Drawing.Point(218, 130);
+      this.mutationRateTextBox.Name = "mutationRateTextBox";
+      this.mutationRateTextBox.Size = new System.Drawing.Size(186, 20);
+      this.mutationRateTextBox.TabIndex = 9;
+      // 
+      // mutationRateLabel
+      // 
+      this.mutationRateLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.mutationRateLabel.AutoSize = true;
+      this.mutationRateLabel.Location = new System.Drawing.Point(65, 133);
+      this.mutationRateLabel.Name = "mutationRateLabel";
+      this.mutationRateLabel.Size = new System.Drawing.Size(77, 13);
+      this.mutationRateLabel.TabIndex = 8;
+      this.mutationRateLabel.Text = "&Mutation Rate:";
+      // 
+      // maximumGenerationsTextBox
+      // 
+      this.maximumGenerationsTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.maximumGenerationsTextBox.Location = new System.Drawing.Point(218, 104);
+      this.maximumGenerationsTextBox.Name = "maximumGenerationsTextBox";
+      this.maximumGenerationsTextBox.Size = new System.Drawing.Size(186, 20);
+      this.maximumGenerationsTextBox.TabIndex = 7;
+      // 
+      // maximumGenerationsLabel
+      // 
+      this.maximumGenerationsLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.maximumGenerationsLabel.AutoSize = true;
+      this.maximumGenerationsLabel.Location = new System.Drawing.Point(65, 107);
+      this.maximumGenerationsLabel.Name = "maximumGenerationsLabel";
+      this.maximumGenerationsLabel.Size = new System.Drawing.Size(114, 13);
+      this.maximumGenerationsLabel.TabIndex = 6;
+      this.maximumGenerationsLabel.Text = "Maximum &Generations:";
+      // 
+      // randomSeedTextBox
+      // 
+      this.randomSeedTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.randomSeedTextBox.Location = new System.Drawing.Point(218, 26);
+      this.randomSeedTextBox.Name = "randomSeedTextBox";
+      this.randomSeedTextBox.Size = new System.Drawing.Size(186, 20);
+      this.randomSeedTextBox.TabIndex = 3;
+      // 
+      // populationSizeTextBox
+      // 
+      this.populationSizeTextBox.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.populationSizeTextBox.Location = new System.Drawing.Point(218, 78);
+      this.populationSizeTextBox.Name = "populationSizeTextBox";
+      this.populationSizeTextBox.Size = new System.Drawing.Size(186, 20);
+      this.populationSizeTextBox.TabIndex = 5;
+      // 
+      // setRandomSeedRandomlyLabel
+      // 
+      this.setRandomSeedRandomlyLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.setRandomSeedRandomlyLabel.AutoSize = true;
+      this.setRandomSeedRandomlyLabel.Location = new System.Drawing.Point(65, 6);
+      this.setRandomSeedRandomlyLabel.Name = "setRandomSeedRandomlyLabel";
+      this.setRandomSeedRandomlyLabel.Size = new System.Drawing.Size(147, 13);
+      this.setRandomSeedRandomlyLabel.TabIndex = 0;
+      this.setRandomSeedRandomlyLabel.Text = "Set &Random Seed Randomly:";
+      // 
+      // randomSeedLabel
+      // 
+      this.randomSeedLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.randomSeedLabel.AutoSize = true;
+      this.randomSeedLabel.Location = new System.Drawing.Point(65, 29);
+      this.randomSeedLabel.Name = "randomSeedLabel";
+      this.randomSeedLabel.Size = new System.Drawing.Size(78, 13);
+      this.randomSeedLabel.TabIndex = 2;
+      this.randomSeedLabel.Text = "&Random Seed:";
+      // 
+      // populationSizeLabel
+      // 
+      this.populationSizeLabel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.populationSizeLabel.AutoSize = true;
+      this.populationSizeLabel.Location = new System.Drawing.Point(65, 81);
+      this.populationSizeLabel.Name = "populationSizeLabel";
+      this.populationSizeLabel.Size = new System.Drawing.Size(83, 13);
+      this.populationSizeLabel.TabIndex = 4;
+      this.populationSizeLabel.Text = "&Population Size:";
+      // 
+      // scopesTabPage
+      // 
+      this.scopesTabPage.Controls.Add(this.scopeView);
+      this.scopesTabPage.Location = new System.Drawing.Point(4, 22);
+      this.scopesTabPage.Name = "scopesTabPage";
+      this.scopesTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.scopesTabPage.Size = new System.Drawing.Size(518, 364);
+      this.scopesTabPage.TabIndex = 2;
+      this.scopesTabPage.Text = "Scopes";
+      this.scopesTabPage.UseVisualStyleBackColor = true;
+      // 
+      // scopeView
+      // 
+      this.scopeView.Caption = "Scope";
+      this.scopeView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.scopeView.Location = new System.Drawing.Point(3, 3);
+      this.scopeView.Name = "scopeView";
+      this.scopeView.Scope = null;
+      this.scopeView.Size = new System.Drawing.Size(512, 358);
+      this.scopeView.TabIndex = 0;
+      // 
+      // abortButton
+      // 
+      this.abortButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.abortButton.Enabled = false;
+      this.abortButton.Location = new System.Drawing.Point(81, 396);
+      this.abortButton.Name = "abortButton";
+      this.abortButton.Size = new System.Drawing.Size(75, 23);
+      this.abortButton.TabIndex = 2;
+      this.abortButton.Text = "&Abort";
+      this.abortButton.UseVisualStyleBackColor = true;
+      this.abortButton.Click += new System.EventHandler(this.abortButton_Click);
+      // 
+      // resetButton
+      // 
+      this.resetButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.resetButton.Location = new System.Drawing.Point(162, 396);
+      this.resetButton.Name = "resetButton";
+      this.resetButton.Size = new System.Drawing.Size(75, 23);
+      this.resetButton.TabIndex = 3;
+      this.resetButton.Text = "&Reset";
+      this.resetButton.UseVisualStyleBackColor = true;
+      this.resetButton.Click += new System.EventHandler(this.resetButton_Click);
+      // 
+      // cloneEngineButton
+      // 
+      this.cloneEngineButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.cloneEngineButton.Location = new System.Drawing.Point(420, 396);
+      this.cloneEngineButton.Name = "cloneEngineButton";
+      this.cloneEngineButton.Size = new System.Drawing.Size(106, 23);
+      this.cloneEngineButton.TabIndex = 4;
+      this.cloneEngineButton.Text = "&Clone Engine...";
+      this.cloneEngineButton.UseVisualStyleBackColor = true;
+      this.cloneEngineButton.Click += new System.EventHandler(this.cloneEngineButton_Click);
+      // 
+      // viewProblemInitializationButton
+      // 
+      this.viewProblemInitializationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.viewProblemInitializationButton.Location = new System.Drawing.Point(410, 208);
+      this.viewProblemInitializationButton.Name = "viewProblemInitializationButton";
+      this.viewProblemInitializationButton.Size = new System.Drawing.Size(53, 20);
+      this.viewProblemInitializationButton.TabIndex = 14;
+      this.viewProblemInitializationButton.Text = "View...";
+      this.viewProblemInitializationButton.UseVisualStyleBackColor = true;
+      this.viewProblemInitializationButton.Click += new System.EventHandler(this.viewProblemInitializationButton_Click);
+      // 
+      // viewSolutionGenerationButton
+      // 
+      this.viewSolutionGenerationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.viewSolutionGenerationButton.Location = new System.Drawing.Point(410, 234);
+      this.viewSolutionGenerationButton.Name = "viewSolutionGenerationButton";
+      this.viewSolutionGenerationButton.Size = new System.Drawing.Size(53, 20);
+      this.viewSolutionGenerationButton.TabIndex = 18;
+      this.viewSolutionGenerationButton.Text = "View...";
+      this.viewSolutionGenerationButton.UseVisualStyleBackColor = true;
+      this.viewSolutionGenerationButton.Click += new System.EventHandler(this.viewSolutionGenerationButton_Click);
+      // 
+      // viewSelectionButton
+      // 
+      this.viewSelectionButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.viewSelectionButton.Location = new System.Drawing.Point(410, 260);
+      this.viewSelectionButton.Name = "viewSelectionButton";
+      this.viewSelectionButton.Size = new System.Drawing.Size(53, 20);
+      this.viewSelectionButton.TabIndex = 22;
+      this.viewSelectionButton.Text = "View...";
+      this.viewSelectionButton.UseVisualStyleBackColor = true;
+      this.viewSelectionButton.Click += new System.EventHandler(this.viewSelectionButton_Click);
+      // 
+      // viewCrossoverButton
+      // 
+      this.viewCrossoverButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.viewCrossoverButton.Location = new System.Drawing.Point(410, 286);
+      this.viewCrossoverButton.Name = "viewCrossoverButton";
+      this.viewCrossoverButton.Size = new System.Drawing.Size(53, 20);
+      this.viewCrossoverButton.TabIndex = 26;
+      this.viewCrossoverButton.Text = "View...";
+      this.viewCrossoverButton.UseVisualStyleBackColor = true;
+      this.viewCrossoverButton.Click += new System.EventHandler(this.viewCrossoverButton_Click);
+      // 
+      // viewMutationButton
+      // 
+      this.viewMutationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.viewMutationButton.Location = new System.Drawing.Point(410, 312);
+      this.viewMutationButton.Name = "viewMutationButton";
+      this.viewMutationButton.Size = new System.Drawing.Size(53, 20);
+      this.viewMutationButton.TabIndex = 30;
+      this.viewMutationButton.Text = "View...";
+      this.viewMutationButton.UseVisualStyleBackColor = true;
+      this.viewMutationButton.Click += new System.EventHandler(this.viewMutationButton_Click);
+      // 
+      // viewEvaluationButton
+      // 
+      this.viewEvaluationButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.viewEvaluationButton.Location = new System.Drawing.Point(410, 338);
+      this.viewEvaluationButton.Name = "viewEvaluationButton";
+      this.viewEvaluationButton.Size = new System.Drawing.Size(53, 20);
+      this.viewEvaluationButton.TabIndex = 34;
+      this.viewEvaluationButton.Text = "View...";
+      this.viewEvaluationButton.UseVisualStyleBackColor = true;
+      this.viewEvaluationButton.Click += new System.EventHandler(this.viewEvaluationButton_Click);
+      // 
+      // SGAEditor
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tabControl);
+      this.Controls.Add(this.cloneEngineButton);
+      this.Controls.Add(this.resetButton);
+      this.Controls.Add(this.abortButton);
+      this.Controls.Add(this.executeButton);
+      this.Name = "SGAEditor";
+      this.Size = new System.Drawing.Size(526, 419);
+      this.tabControl.ResumeLayout(false);
+      this.parametersTabPage.ResumeLayout(false);
+      this.parametersTabPage.PerformLayout();
+      this.scopesTabPage.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button executeButton;
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage parametersTabPage;
+    private System.Windows.Forms.Button abortButton;
+    private System.Windows.Forms.Button resetButton;
+    private System.Windows.Forms.TextBox mutationRateTextBox;
+    private System.Windows.Forms.Label mutationRateLabel;
+    private System.Windows.Forms.TextBox populationSizeTextBox;
+    private System.Windows.Forms.Label populationSizeLabel;
+    private System.Windows.Forms.TabPage scopesTabPage;
+    private System.Windows.Forms.TextBox maximumGenerationsTextBox;
+    private System.Windows.Forms.Label maximumGenerationsLabel;
+    private System.Windows.Forms.TextBox elitesTextBox;
+    private System.Windows.Forms.Label elitesLabel;
+    private System.Windows.Forms.TextBox randomSeedTextBox;
+    private System.Windows.Forms.Label setRandomSeedRandomlyLabel;
+    private System.Windows.Forms.Label randomSeedLabel;
+    private System.Windows.Forms.CheckBox setRandomSeedRandomlyCheckBox;
+    private System.Windows.Forms.Label problemInitializationLabel;
+    private System.Windows.Forms.Label evaluationLabel;
+    private System.Windows.Forms.Label mutationLabel;
+    private System.Windows.Forms.Label crossoverLabel;
+    private System.Windows.Forms.Label solutionGenerationLabel;
+    private System.Windows.Forms.Button cloneEngineButton;
+    private System.Windows.Forms.TextBox mutationTextBox;
+    private System.Windows.Forms.TextBox crossoverTextBox;
+    private System.Windows.Forms.TextBox selectionTextBox;
+    private System.Windows.Forms.TextBox solutionGenerationTextBox;
+    private System.Windows.Forms.TextBox problemInitializationTextBox;
+    private System.Windows.Forms.Label selectionLabel;
+    private System.Windows.Forms.TextBox evaluationTextBox;
+    private System.Windows.Forms.Button setProblemInitializationButton;
+    private System.Windows.Forms.Button setEvaluationButton;
+    private System.Windows.Forms.Button setMutationButton;
+    private System.Windows.Forms.Button setCrossoverButton;
+    private System.Windows.Forms.Button setSelectionButton;
+    private System.Windows.Forms.Button setSolutionGenerationButton;
+    private HeuristicLab.Core.ScopeView scopeView;
+    private System.Windows.Forms.Button viewEvaluationButton;
+    private System.Windows.Forms.Button viewMutationButton;
+    private System.Windows.Forms.Button viewCrossoverButton;
+    private System.Windows.Forms.Button viewSelectionButton;
+    private System.Windows.Forms.Button viewSolutionGenerationButton;
+    private System.Windows.Forms.Button viewProblemInitializationButton;
+  }
+}
Index: trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.cs
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.cs	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.cs	(revision 1865)
@@ -0,0 +1,220 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.SGA {
+  /// <summary>
+  /// Visual representation of the <see cref="SGA"/> class.
+  /// </summary>
+  public partial class SGAEditor : EditorBase {
+    private ChooseOperatorDialog chooseOperatorDialog;
+
+    /// <summary>
+    /// Gets or sets the <see cref="SGA"/> item to represent visually.
+    /// </summary>
+    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="EditorBase"/>.
+    /// No own data storage present!</remarks>
+    public SGA SGA {
+      get { return (SGA)Item; }
+      set { base.Item = value; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="SGAEditor"/>.
+    /// </summary>
+    public SGAEditor() {
+      InitializeComponent();
+    }
+    /// <summary>
+    /// Initializes a new instance of <see cref="SGAEditor"/> with the given <paramref name="sga"/>.
+    /// </summary>
+    /// <param name="sga">The simple genetic algorithm to represent visually.</param>
+    public SGAEditor(SGA sga)
+      : this() {
+      SGA = sga;
+    }
+
+    /// <summary>
+    /// Removes the eventhandlers from the underlying <see cref="IEngine"/> of the <see cref="SGA"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="EditorBase"/>.</remarks>
+    protected override void RemoveItemEvents() {
+      SGA.Engine.ExceptionOccurred -= new EventHandler<ExceptionEventArgs>(Engine_ExceptionOccurred);
+      SGA.Engine.Finished -= new EventHandler(Engine_Finished);
+      scopeView.Scope = null;
+      base.RemoveItemEvents();
+    }
+    /// <summary>
+    /// Adds eventhandlers to the underlying <see cref="IEngine"/> of the <see cref="SGA"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="EditorBase"/>.</remarks>
+    protected override void AddItemEvents() {
+      base.AddItemEvents();
+      SGA.Engine.ExceptionOccurred += new EventHandler<ExceptionEventArgs>(Engine_ExceptionOccurred);
+      SGA.Engine.Finished += new EventHandler(Engine_Finished);
+      SetDataBinding();
+      scopeView.Scope = SGA.Engine.GlobalScope;
+    }
+
+    /// <summary>
+    /// Updates all controls with the latest data of the model.
+    /// </summary>
+    /// <remarks>Calls <see cref="EditorBase.UpdateControls"/> of base class <see cref="EditorBase"/>.</remarks>
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      if (SGA == null) {
+        tabControl.Enabled = false;
+      } else {
+        tabControl.Enabled = true;
+        problemInitializationTextBox.Text = SGA.ProblemInjector.GetType().Name;
+        solutionGenerationTextBox.Text = SGA.SolutionGenerator.GetType().Name;
+        selectionTextBox.Text = SGA.Selector.GetType().Name;
+        crossoverTextBox.Text = SGA.Crossover.GetType().Name;
+        mutationTextBox.Text = SGA.Mutator.GetType().Name;
+        evaluationTextBox.Text = SGA.Evaluator.GetType().Name;
+      }
+    }
+
+    private void SetDataBinding() {
+      setRandomSeedRandomlyCheckBox.DataBindings.Add("Checked", SGA, "SetSeedRandomly");
+      randomSeedTextBox.DataBindings.Add("Text", SGA, "Seed");
+      populationSizeTextBox.DataBindings.Add("Text", SGA, "PopulationSize");
+      maximumGenerationsTextBox.DataBindings.Add("Text", SGA, "MaximumGenerations");
+      mutationRateTextBox.DataBindings.Add("Text", SGA, "MutationRate");
+      elitesTextBox.DataBindings.Add("Text", SGA, "Elites");
+    }
+
+    #region Button Events
+    private void viewProblemInitializationButton_Click(object sender, EventArgs e) {
+      IView view = SGA.ProblemInjector.CreateView();
+      if (view != null)
+        PluginManager.ControlManager.ShowControl(view);
+    }
+    private void viewSolutionGenerationButton_Click(object sender, EventArgs e) {
+      IView view = SGA.SolutionGenerator.CreateView();
+      if (view != null)
+        PluginManager.ControlManager.ShowControl(view);
+    }
+    private void viewSelectionButton_Click(object sender, EventArgs e) {
+      IView view = SGA.Selector.CreateView();
+      if (view != null)
+        PluginManager.ControlManager.ShowControl(view);
+    }
+    private void viewCrossoverButton_Click(object sender, EventArgs e) {
+      IView view = SGA.Crossover.CreateView();
+      if (view != null)
+        PluginManager.ControlManager.ShowControl(view);
+    }
+    private void viewMutationButton_Click(object sender, EventArgs e) {
+      IView view = SGA.Mutator.CreateView();
+      if (view != null)
+        PluginManager.ControlManager.ShowControl(view);
+    }
+    private void viewEvaluationButton_Click(object sender, EventArgs e) {
+      IView view = SGA.Evaluator.CreateView();
+      if (view != null)
+        PluginManager.ControlManager.ShowControl(view);
+    }
+    private void setProblemInitializationButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        SGA.ProblemInjector = chooseOperatorDialog.Operator;
+        problemInitializationTextBox.Text = SGA.ProblemInjector.GetType().Name;
+      }
+    }
+    private void setSolutionGenerationButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        SGA.SolutionGenerator= chooseOperatorDialog.Operator;
+        solutionGenerationTextBox.Text = SGA.SolutionGenerator.GetType().Name;
+      }
+    }
+    private void setSelectionButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        SGA.Selector = chooseOperatorDialog.Operator;
+        selectionTextBox.Text = SGA.Selector.GetType().Name;
+      }
+    }
+    private void setCrossoverButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        SGA.Crossover = chooseOperatorDialog.Operator;
+        crossoverTextBox.Text = SGA.Crossover.GetType().Name;
+      }
+    }
+    private void setMutationButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        SGA.Mutator = chooseOperatorDialog.Operator;
+        mutationTextBox.Text = SGA.Mutator.GetType().Name;
+      }
+    }
+    private void setEvaluationButton_Click(object sender, EventArgs e) {
+      if (chooseOperatorDialog == null) chooseOperatorDialog = new ChooseOperatorDialog();
+      if (chooseOperatorDialog.ShowDialog(this) == DialogResult.OK) {
+        SGA.Evaluator = chooseOperatorDialog.Operator;
+        evaluationTextBox.Text = SGA.Evaluator.GetType().Name;
+      }
+    }
+    private void executeButton_Click(object sender, EventArgs e) {
+      executeButton.Enabled = false;
+      abortButton.Enabled = true;
+      SGA.Engine.Execute();
+    }
+    private void abortButton_Click(object sender, EventArgs e) {
+      SGA.Engine.Abort();
+    }
+    private void resetButton_Click(object sender, EventArgs e) {
+      SGA.Engine.Reset();
+    }
+    private void cloneEngineButton_Click(object sender, EventArgs e) {
+      IEngine clone = (IEngine)SGA.Engine.Clone();
+      IEditor editor = ((IEditable)clone).CreateEditor();
+      PluginManager.ControlManager.ShowControl(editor);
+    }
+    #endregion
+
+    #region Engine Events
+    private delegate void OnExceptionEventDelegate(object sender, ExceptionEventArgs e);
+    private void Engine_ExceptionOccurred(object sender, ExceptionEventArgs e) {
+      if (InvokeRequired)
+        Invoke(new OnExceptionEventDelegate(Engine_ExceptionOccurred), sender, e);
+      else
+        Auxiliary.ShowErrorMessageBox(e.Exception);
+    }
+    private void Engine_Finished(object sender, EventArgs e) {
+      scopeView.Refresh();
+      executeButton.Enabled = true;
+      abortButton.Enabled = false;
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.resx
===================================================================
--- trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.resx	(revision 1865)
+++ trunk/sources/HeuristicLab.SGA/3.3/SGAEditor.resx	(revision 1865)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
